/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package sga;

/**
 *
 * @author fanda
 */
public class StatData {
    
    /**
     * Best fitness in the population (best-so-far).
     */
    public static double fbest;   
    
    /**
     * Average fitness of the chromosomes.
     */
    public static double favg;     
    
    /**
     * Fitness of the worst chromosome.
     */
    public static double fworst;   
    
    /**
     * Sum of fitness values over the whole population.
     */ 
    public static double fsum;    
    
    /**
     * Index of the best individual.
     */
    public static int indbest;     
    
    /**
     * Index of the worst individual
     */
    public static int indworst;   
    
    /**
     * Stores statistics of actual population.
     * @param p population of individuals
     */
    public static void getStatistics(Individual[] p) {
	// Init statistics data.
	fbest = -10000.0;
	fworst = 10000;
	favg = 0.0;
	fsum = 0.0;
	indbest = 0;
	indworst = 0;
        
        for(int i = 0; i < SGA.popSize; i++){
            if(fbest <= p[i].fitness) {
                fbest = p[i].fitness;   // Store best fitness value.
                indbest = i;              // Store best fitness individual index.
            }
            if(fworst >= p[i].fitness) {
                fworst = p[i].fitness;    // Store worst fitness value.
                indworst = i;             // Stroe worst fitness individual index.
            }
            fsum += p[i].fitness;           // Calculate fitness sum of whole population.
	}
        
        favg = fsum / SGA.popSize;  // Calculate average fitness value in population.
    }
    
    /**
     * Prints evolution progress information on standard output.
     * @param evals number of total evaluations during evolution.
     */
    public static void reportResults(int evals) {
        System.out.println("---------------------------------------------------------");
        System.out.println("evals: " + evals + " fbest: " + fbest + " favg: " + favg);
    }
    
    /**
     * Prints value of individual and its fitness value on standard output.
     * @param p population of individuals.
     */
    public static void printBest(Individual[] p) {
        double pom = Math.pow(2.0, SGA.maxGenes) - 1.0; 
        double x;

        // Decode parameter x.
        x = p[indbest].decode(0, SGA.maxGenes);  // Get the decimal value of all 24 bits.
        x = SGA.minX + (x / pom) * Individual.rozsahX;

    	// Print the values of x on standard output.
        System.out.println("result: " + x + " fitness " + p[indbest].fitness);
    }
}
